program RenTrunc; {rename files cutting out some parts of the filename}
{$APPTYPE CONSOLE} {$I-}
uses Strings,Windows;
const
   maxparm = 128;
   maxfile = 1024;
type
   csr = record {cut string record}
      ls : integer; {length of cs}
      cs : string;
      end;
   rfr = record {rename files record}
      fn1,fn2 : string;
      end;
var
   OK : Boolean;
   i,n,i1,i2,cf,nc,nc1,nf : integer;
   s,fn1,fn2,fn0 : string;
   csa : array[1..maxparm] of csr;
   rfa : array[1..maxfile] of rfr;
   f : file;
   fd : WIN32_FIND_DATA;
   fh : HANDLE;
   p1 : PChar;
   found : BOOL;

{****************************************************************************}

function GetParmCount : integer;
{-1 : error; 0 : executable; 1... parameters on command line}
var
   s : string;
   i,ip1,n : integer;
   quoted,white : Boolean;
begin
s:=StrPas(CmdLine);
n:=Length(s); quoted:=false; ip1:=-1; white:=true;
for i:=1 to n do if s[i]='"' then begin
   if not quoted then begin
      ip1:=ip1+1; {new parameter}
      white:=false;
      end;
   quoted:=not quoted;
   end
  else if quoted then white:=false
  else if s[i]=' ' then white:=true
  else if white then begin
   white:=false;
   ip1:=ip1+1;
   end
  else white:=false;
GetParmCount:=ip1;
end;

{****************************************************************************}

function GetParm(ip : integer) : string;
var
   s,ps : string;
   i,ip1,n : integer;
   fc : array[0..maxparm,1..2] of integer;
   quoted,white : Boolean;
begin
ps:='';
s:=StrPas(CmdLine);
n:=Length(s); quoted:=false; ip1:=-1; white:=true;
for i:=1 to n do if s[i]='"' then begin
   if quoted then fc[ip1,2]:=i else begin
      ip1:=ip1+1; {new parameter}
      fc[ip1,1]:=i;
      white:=false;
      end;
   quoted:=not quoted;
   end
  else if quoted then begin
   white:=false; fc[ip1,2]:=i;
   end
  else if s[i]=' ' then white:=true
  else if white then begin
   white:=false;
   ip1:=ip1+1;
   fc[ip1,1]:=i;
   end
  else begin
   white:=false;
   fc[ip1,2]:=i;
   end;
if ip<=ip1 then ps:=Copy(s,fc[ip,1],fc[ip,2]-fc[ip,1]+1);
GetParm:=ps;
end;

{*****************************************************************************}

procedure Usage;
begin
Writeln('');
Writeln('RenTrunc renames files cutting out some parts of the name. Usage:');
Writeln('RenTrunc filemask [options]');
Writeln('     /F:n           truncate first n characters');
Writeln('     /C:part        cut out substring part');
Writeln('    "/C:part "      cut out substring part (containing space)');
Writeln('');
Halt(1);
end;

{*****************************************************************************}

begin
n:=GetParmCount; nc:=0; nf:=0; cf:=0;
if n<2 then Usage else begin
   fn0:=GetParm(1);
   for i:=2 to n do begin
      s:=GetParm(i); 
      if (Copy(s,1,3)='/F:') or (Copy(s,1,3)='/f:') then begin
         Val(Copy(s,4,Length(s)-3),cf,i2);
         end;
      if (Copy(s,1,3)='/C:') or (Copy(s,1,3)='/c:') then begin
         nc:=nc+1;
         csa[nc].cs:=Copy(s,4,Length(s)-3);
         csa[nc].ls:=Length(csa[nc].cs);
         if csa[nc].ls=0 then nc:=nc-1;
         end;
      if (Copy(s,1,4)='"/C:') or (Copy(s,1,4)='"/c:') then begin
         nc:=nc+1;
         csa[nc].cs:=Copy(s,5,Length(s)-5);
         csa[nc].ls:=Length(csa[nc].cs);
         if csa[nc].ls=0 then nc:=nc-1;
         end;
      end;
   if (cf<0) or (cf=0) and (nc=0) then Usage;
   end;
GetMem(p1,MAX_PATH);
StrPCopy(p1,fn0);
fh:=FindFirstFile(p1,fd);
found:=(fh<>INVALID_HANDLE_VALUE);
while found do begin
   OK:=false;
   fn1:=StrPas(fd.cFileName);
   Assign(f,fn1);
   OK:=( IOResult=0 );
   fn2:=Copy(fn1,cf+1,Length(fn1)-cf);
   for i:=1 to nc do begin
      nc1:=0;
      if OK then begin
         i1:=Pos(csa[i].cs,fn2);
         i2:=Length(fn2);
         if (i1=0) or (i1>i2) then OK:=false;
         end;
      if OK then fn2:=Copy(fn2,1,i1-1)+
       Copy(fn2,i1+csa[i].ls,i2-csa[i].ls-i1+1);
      if OK then nc1:=nc1+1;
      end;
   if (nf<maxfile) and ((cf>0) or (nc1>0)) then begin
      nf:=nf+1;
      rfa[nf].fn1:=fn1;
      rfa[nf].fn2:=fn2;
      Writeln(fn1,' => ',fn2);
      end;
   found:=FindNextFile(fh,fd);
   end;
found:=FindClose(fh);
FreeMem(p1,MAX_PATH);
for i:=1 to nf do begin
   Assign(f,rfa[i].fn1);
   Rename(f,rfa[i].fn2);
   end;
Writeln(nf, ' files renamed.');
end.

