program Win32Test; {A template skeleton for a GUI application, where the resources
come from a DLL compiled with MS Visual C++}
{$APPTYPE GUI}
uses Strings,Windows;

const
   ss = 255; {string size}
   maxlegend = 512;
   ResMod = 'us_res.dll'; {name of the resource DLL}
var
   WinHomeDir,Windir,PrgName,PrgDir,WorkDir : string;
   WHandler,RHandler,IHandler,AHandler,MHandler,DHandler : HANDLE;
   Legend : array[1..maxlegend] of PChar;
   m,NLegend : integer;
   WMessage : MSG;

{For the sake of simplicity, now everything is in one program file. In a larger
applicataion it is useful to divide the code to units and a main program.}

{Dialog callback functions}
{*****************************************************************************}

function D6001_CBF(Dialog: HWnd; Message : UINT; WPm : WPARAM;
 LPm : LPARAM) : LRESULT; stdcall; export; {Help about}
begin
D6001_CBF:=0;
if Message=WM_INITDIALOG then begin
   end
  else if Message=WM_COMMAND then case LoWord(Wpm) of
   101 : EndDialog(Dialog,1);
   end
  else;
end;

{Menu procedures}
{*****************************************************************************}

procedure DisplayHello;
var
   OKw : BOOL;
   wcr : RECT;
   i : integer;
begin
OKw:=GetClientRect(WHandler,@wcr); {Get dimensions of window}
wcr.right:=wcr.right-wcr.left; wcr.bottom:=wcr.bottom-wcr.top;
i:=FillRect(DHandler,wcr,GetStockObject(LTGRAY_BRUSH));{clean window}
{Display "Hello, World!" in the middle of the window}
i:=DrawText(DHandler,'Hello, World!',Length('Hello, World!'),@wcr,
 DT_CENTER or DT_VCENTER or DT_SINGLELINE);
end;

{*****************************************************************************}

procedure DrawEllipse;
var
   OKw : BOOL;
   wcr : RECT;
   i : integer;
begin
OKw:=GetClientRect(WHandler,@wcr); {Get dimensions of window}
wcr.right:=wcr.right-wcr.left; wcr.bottom:=wcr.bottom-wcr.top;
i:=FillRect(DHandler,wcr,GetStockObject(LTGRAY_BRUSH));{clean window}
{Draw ellipse with the default pen}
OKw:=Ellipse(DHandler,Round(0.1*wcr.right),Round(0.1*wcr.bottom),
 Round(0.9*wcr.right),Round(0.9*wcr.bottom));
end;

{*****************************************************************************}

procedure HelpAbout;
var
   i : integer;
begin
i:=DialogBox(RHandler,MAKEINTRESOURCE(6001),WHandler,DlgProc(@D6001_CBF));
end;

{Mandatory part of the Win32 GUI program}
{*****************************************************************************}
{The essence of the menu system: the main window callback function}

function MainWindowCBF(Window : HWND; Message : UINT; WPm : WPARAM;
 LPm : LPARAM) : LRESULT; stdcall; export;
begin
MainWindowCBF:=0;
if Message=WM_COMMAND {273} then begin
   case LoWord(WPm) of {If an accelerator key was used, the high word is set}
   {response to menu events}
      109 : PostQuitMessage(0); {File - Exit}
      201 : DisplayHello;
      202 : DrawEllipse;
      909 : HelpAbout;
      end;
   end
  else if Message=WM_DESTROY then PostQuitMessage(0) {[X] button of the window}
  else MainWindowCBF:=DefWindowProc(Window, Message, WPm, LPm);
end;

{*****************************************************************************}

procedure StartMainWindow; {Initializations}
var
   OKw : BOOL;
   WindowClass: TWndClass;
   AWC : HANDLE;
   p : PChar;
   i,n : integer;
   OK : Boolean;
begin
OK:=true;
GetMem(p,ss);
{It is useful to collect directory names here}
i:=GetWindowsDirectory(p,ss);
WinHomeDir:=StrPas(p);
i:=GetSystemDirectory(p,ss);
WinDir:=StrPas(p);
i:=GetModuleFileName(HInstance,p,ss);
PrgName:=StrPas(p);
while (i>0) and (PrgName[i]<>'\') do i:=i-1;
if i>0 then PrgDir:=Copy(PrgName,1,i-1);
GetDir(0,WorkDir);
{Load resources}
StrPCopy(p,PrgDir+'\'+ResMod);{PrgDir+'\'+LangStr+'_RES.DLL' : easy way to use multiple languages}
RHandler:=LoadLibrary(p);
if RHandler<HINSTANCE_ERROR then begin
   StrPCopy(p,'Cannot load '+ResMod);
   i:=MessageBox(HWND_DESKTOP,p,'Win32Test Error',MB_OK);
   OK:=false;
   end;
IHandler:=LoadIcon(RHandler,MAKEINTRESOURCE(7001));
AHandler:=LoadAccelerators(RHandler,MAKEINTRESOURCE(3001));
MHandler:=LoadMenu(RHandler,MAKEINTRESOURCE(4001));
{Is practical to store strings in a resource DLL's string table, makes easier
to translate your program to other languages}
NLegend:=0; n:=1;
while OK and (NLegend<MaxLegend) and (n>0)do begin
   n:=LoadString(RHandler,NLegend+1,p,ss);
   if n>0 then begin
      NLegend:=NLegend+1;
      GetMem(Legend[NLegend],n+1);
      StrCopy(Legend[NLegend],p);
      end;
   end;
FreeMem(p,ss);
if not OK then Halt(1);
{i:=MessageBox(HWND_DESKTOP,'Resources loaded','Win32Test Message',MB_OK);}
if HPrevInst = 0 then begin {fill in WindowClass structure}
   WindowClass.style:=CS_HREDRAW or CS_VREDRAW or CS_BYTEALIGNCLIENT or
    CS_BYTEALIGNWINDOW;
   WindowClass.lpfnWndProc:= WndProc(@MainWindowCBF);
   WindowClass.cbClsExtra:= 0;
   WindowClass.cbWndExtra:= 0;
   WindowClass.hInstance := HInstance;
   WindowClass.hIcon := IHandler;
   WindowClass.hCursor := LoadCursor(0, IDC_ARROW);
   WindowClass.hbrBackground := GetStockObject(LTGRAY_BRUSH);
   WindowClass.lpszMenuName:= MAKEINTRESOURCE(4001);
   WindowClass.lpszClassName:= 'Win32Test';
   AWC:=RegisterClass(WindowClass);
   if AWC=0 then begin
      i:=MessageBox(HWND_DESKTOP,'Window class cannot be registered',
       'Win32Test error',MB_OK);
      Halt(1);
      end;
   end;
WHandler:=CreateWindow( {create the main window of the program}
    'Win32Test',
    Legend[1],
    WS_OVERLAPPEDWINDOW or WS_CLIPCHILDREN,
    0,0,500,400,
    HWND_DESKTOP,
    MHandler,
    HInstance,
    nil);
OKw:=ShowWindow(WHandler,SW_SHOW);
UpdateWindow(WHandler);
DHandler:=GetDC(WHandler); {get device context of window}
end;

{*****************************************************************************}

procedure CloseMainWindow; {clean-up}
var
   OKw : BOOL;
   i : integer;
begin
OKw:=DestroyWindow(WHandler);
OKw:=UnregisterClass('Win32Test',HInstance);
for i:=NLegend downto 1 do FreeMem(Legend[i],StrLen(Legend[i])+1);
OKw:=DestroyMenu(MHandler);
OKw:=DestroyIcon(IHandler);
OKw:=FreeLibrary(RHandler);
end;

{******************************** Main block *********************************}

begin
{Initialize program}
StartMainWindow;
{Main message loop: the operating system watches events: timer, user actions,
etc., and sends messages to the running applications. These messages are stored
in the so-called message queue, from where we have to pick them. The next cycle
runs until a WM_QUIT message is received.}
while GetMessage(@WMessage, 0, 0, 0) do if
 TranslateAccelerator(WHandler,AHandler,@WMessage)=0 then begin
   TranslateMessage(@WMessage);
   DispatchMessage(@WMessage); {from here is called MainWindowCBF}
   end;
{Clean-up before exit}
CloseMainWindow;
end.

