program XAttrib; { (C) Dancs Andrs, 2003.}
{$APPTYPE CONSOLE}
uses SysUtils,Strings,Windows;
const
   maxdir = 1024;
   ss = 255;
   FAA : array[1..8] of DWORD = (
    FILE_ATTRIBUTE_ARCHIVE,
    FILE_ATTRIBUTE_COMPRESSED,
    FILE_ATTRIBUTE_DIRECTORY,
    FILE_ATTRIBUTE_HIDDEN,
    FILE_ATTRIBUTE_NORMAL,
    FILE_ATTRIBUTE_READONLY,
    FILE_ATTRIBUTE_SYSTEM,
    FILE_ATTRIBUTE_TEMPORARY);
   FAcA : array[1..8] of char = ('A','C','D','H','N','R','S','T');
   FAi : array[1..4] of integer = (1,4,6,7); {index of allowed to set}
var
   s,SearchMask,RootDir,fn : string;
   FR : WIN32_FIND_DATA;
   ffh : Handle;
   LE,FAadd,FAclear,FileAttrib : DWORD;
   p : PChar;
   OKw : BOOL;
   TextOK : Boolean;
   path : array[1..maxdir] of string;
   n,i,j,ls,l,ndir,n1,n2,n3,idir : integer;

{****************************************************************************}

procedure Usage;
begin
Writeln('XAttrib sets file attributes in a whole directory tree.');
Writeln('Works under Win32. Freeware. Syntax:');
Writeln('XAttrib [-A|+A] [/R=root_directory] [/M=mask]');
Writeln('     -    clear');
Writeln('     +    set');
Writeln('     A    archive, other possible values: R read-only, S system, H hidden');
Writeln('Use "" for parameters containing spaces or other special characters.');
Writeln('');
Halt(1);
end;

{****************************************************************************}

function GetParmCount : integer;
{-1 : error; 0 : executable; 1... parameters on command line}
var
   s : string;
   i,ip1,n : integer;
   quoted,white : Boolean;
begin
s:=StrPas(CmdLine); 
n:=Length(s); quoted:=false; ip1:=-1; white:=true;
for i:=1 to n do if s[i]='"' then begin
   if not quoted then begin
      ip1:=ip1+1; {new parameter}
      white:=false;
      end;
   quoted:=not quoted;
   end
  else if quoted then white:=false
  else if s[i]=' ' then white:=true
  else if white then begin
   white:=false;
   ip1:=ip1+1;
   end
  else white:=false;
GetParmCount:=ip1; 
end;

{****************************************************************************}

function GetParm(ip : integer) : string;
var
   s,ps : string;
   i,ip1,n : integer;
   fc : array[0..64,1..2] of integer;
   quoted,white : Boolean;
begin
ps:='';
s:=StrPas(CmdLine);
n:=Length(s); quoted:=false; ip1:=-1; white:=true;
for i:=1 to n do if s[i]='"' then begin
   if quoted then fc[ip1,2]:=i else begin
      ip1:=ip1+1; {new parameter}
      fc[ip1,1]:=i;
      white:=false;
      end;
   quoted:=not quoted;
   end
  else if quoted then begin
   white:=false; fc[ip1,2]:=i;
   end
  else if s[i]=' ' then white:=true
  else if white then begin
   white:=false;
   ip1:=ip1+1;
   fc[ip1,1]:=i;
   end
  else begin
   white:=false;
   fc[ip1,2]:=i;
   end;
if ip<=ip1 then ps:=Copy(s,fc[ip,1],fc[ip,2]-fc[ip,1]+1);
GetParm:=ps;
end;

{****************************************************************************}

function AttribStr(a : DWORD) : string;
var
   s : string[8];
   i : integer;
begin
s:=Space(8);
for i:=1 to 8 do if ((a and FAA[i])=FAA[i]) then s[i]:=FAcA[i];
AttribStr:=s;
end;

{****************************************************************************}

begin
{Analyze command line parameters}
SearchMask:='*.*'; RootDir:=''; FAadd:=0; FAclear:=0;
n:=GetParmCount;
if n<1 then Usage else for i:=1 to n do begin
   s:=GetParm(i); ls:=Length(s); 
   if (s[1]='"') and (s[ls]='"') then begin
      s:=Copy(s,2,ls-2);
      ls:=Length(s);
      end;
   if s[1]='/' then begin
      if UpCase(s[2])='R' then RootDir:=Copy(s,4,ls-3)
        else if UpCase(s[2])='M' then SearchMask:=Copy(s,4,ls-3)
        else if UpCase(s[2])='H' then Usage
        else if s[2]='?' then Usage
        else;
      end
     else if s[1]='-' then begin
      for j:=1 to 4 do
       if UpCase(s[2])=FAcA[FAi[j]] then FAclear:=(FAclear or FAA[FAi[j]]);
      end
     else if s[1]='+' then begin
      for j:=1 to 4 do
       if UpCase(s[2])=FAcA[FAi[j]] then FAadd:=(FAadd or FAA[FAi[j]]);
      end
     else;
   end;
GetMem(p,ss);
{First pass: gather directory names}
ndir:=1;
if RootDir='' then begin
   ls:=GetCurrentDirectory(ss,p);
   path[1]:=StrPas(p);
   end
  else path[1]:=RootDir;
n1:=1; n2:=1;
repeat
   n3:=0;
   for idir:=n1 to n2 do begin
      StrPCopy(p,path[idir]+'\*.*');
      ffh:=FindFirstFile(p,FR);
      if ffh=INVALID_HANDLE_VALUE then LE:=GetLastError else LE:=0;
      while LE=0 do begin
         fn:=StrPas(FR.cFileName);
         if (FR.dwFileAttributes and FILE_ATTRIBUTE_DIRECTORY =
          FILE_ATTRIBUTE_DIRECTORY) and (fn<>'.') and (fn<>'..') then begin
            if ndir>maxdir then begin
               Writeln('Too much subdirectories');
               Halt(1);
               end
              else begin
               ndir:=ndir+1; n3:=n3+1;
               path[ndir]:=path[idir]+'\'+fn;
               end;
            end;
         if FindNextFile(ffh,FR) then LE:=0 else LE:=GetLastError;
         end;
      if not FindClose(ffh) then LE:=GetLastError;
      end;
   if n3>0 then begin
      n1:=n2+1; n2:=ndir;
      end;
   until n3=0;
{order path}
if ndir>2 then for i:=1 to ndir do for j:=i+1 to ndir do
 if path[i]>path[j] then begin
   fn:=path[i];
   path[i]:=path[j];
   path[j]:=fn;
   end;
{Second pass: set the attributes}
l:=0; Writeln('');
for idir:=1 to ndir do begin
   StrPCopy(p,path[idir]+'\'+SearchMask);
   ffh:=FindFirstFile(p,FR);
   if ffh=INVALID_HANDLE_VALUE then LE:=GetLastError else LE:=0;
   while LE=0 do begin
      fn:=StrPas(FR.cFileName);
      TextOK:=true;
      Write(AttribStr(FR.dwFileAttributes),' ',Copy(path[idir]+'\'+fn,1,70));
      if (fn='.') or (fn='..') then TextOK:=false;
      if (FR.dwFileAttributes and FILE_ATTRIBUTE_DIRECTORY =
       FILE_ATTRIBUTE_DIRECTORY) then TextOK:=false;
      if TextOK then begin
         StrPCopy(p,path[idir]+'\'+fn);
         FileAttrib:=(FR.dwFileAttributes or FAadd);
         FileAttrib:= (FileAttrib and not FAclear);
         if FileAttrib<>Fr.dwFileAttributes then begin
             OKw:=SetFileAttributes(p,FileAttrib);
             Write(Chr(13),AttribStr(FileAttrib));
             end;
         end;
      Writeln('');
      if FindNextFile(ffh,FR) then LE:=0 else LE:=GetLastError;
      end;
   if not FindClose(ffh) then LE:=GetLastError;
   end;
Writeln('Ready.');
FreeMem(p,ss);
end.
