program XFind; {(C) Dancs Andrs, 2003.}
{$APPTYPE CONSOLE}
uses Strings,Windows;
const
   maxdir = 1024;
   ss = 255;
   rch : array [1..4] of char = ('-','/','|','\');
var
   s,s1,SearchMask,SearchStr,RootDir,answer,fn : string;
   FR : WIN32_FIND_DATA;
   ffh : Handle;
   LE : DWORD;
   p : PChar;
   PerPage,CaseInsensitive,found,TextOK : Boolean;
   path : array[1..maxdir] of string;
   ir,n,i,j,ls,l,ndir,n1,n2,n3,idir : integer;
   f : text;

{****************************************************************************}

procedure Usage;
begin
Writeln('XFind searches whole directory trees for a string.');
Writeln('Works under Win32. Freeware. Syntax:');
Writeln('XFind search_string [/R=root_directory] [/M=mask] [/I] [/P]');
Writeln('     /I   case insensitive');
Writeln('     /P   stop before scrolling');
Writeln('Use "" for parameters containing spaces or other special characters.');
Writeln('');
Halt(1);
end;

{****************************************************************************}

function GetParmCount : integer;
{-1 : error; 0 : executable; 1... parameters on command line}
var
   s : string;
   i,ip1,n : integer;
   quoted,white : Boolean;
begin
s:=StrPas(CmdLine);
n:=Length(s); quoted:=false; ip1:=-1; white:=true;
for i:=1 to n do if s[i]='"' then begin
   if not quoted then begin
      ip1:=ip1+1; {new parameter}
      white:=false;
      end;
   quoted:=not quoted;
   end
  else if quoted then white:=false
  else if s[i]=' ' then white:=true
  else if white then begin
   white:=false;
   ip1:=ip1+1;
   end
  else white:=false;
GetParmCount:=ip1;
end;

{****************************************************************************}

function GetParm(ip : integer) : string;
var
   s,ps : string;
   i,ip1,n : integer;
   fc : array[0..64,1..2] of integer;
   quoted,white : Boolean;
begin
ps:='';
s:=StrPas(CmdLine);
n:=Length(s); quoted:=false; ip1:=-1; white:=true;
for i:=1 to n do if s[i]='"' then begin
   if quoted then fc[ip1,2]:=i else begin
      ip1:=ip1+1; {new parameter}
      fc[ip1,1]:=i;
      white:=false;
      end;
   quoted:=not quoted;
   end
  else if quoted then begin
   white:=false; fc[ip1,2]:=i;
   end
  else if s[i]=' ' then white:=true
  else if white then begin
   white:=false;
   ip1:=ip1+1;
   fc[ip1,1]:=i;
   end
  else begin
   white:=false;
   fc[ip1,2]:=i;
   end;
if ip<=ip1 then ps:=Copy(s,fc[ip,1],fc[ip,2]-fc[ip,1]+1);
GetParm:=ps;
end;

{*****************************************************************************}

procedure Rotor;
begin
ir:=ir+1; if (ir<1) or (ir>4) then ir:=1;
Write(Chr(8),rch[ir]);
end;

{*****************************************************************************}

procedure WaitIfScreenFull;
begin
if PerPage then begin
   l:=l+1;
   if l=24 then begin
      Write('     Press Enter to continue...'); Readln(answer);
      l:=0;
      end;
   end;
end;

{****************************************************************************}

begin
{Analyze command line parameters}
SearchMask:='*.*'; SearchStr:=''; RootDir:=''; PerPage:=false;
CaseInsensitive:=false;
n:=GetParmCount;
if n<1 then Usage else for i:=1 to n do begin
   s:=GetParm(i); ls:=Length(s);
   if (s[1]='"') and (s[ls]='"') then begin
      s:=Copy(s,2,ls-2);
      ls:=Length(s);
      end;
   if s[1]='/' then begin
      if UpCase(s[2])='R' then RootDir:=Copy(s,4,ls-3)
        else if UpCase(s[2])='M' then SearchMask:=Copy(s,4,ls-3)
        else if UpCase(s[2])='P' then PerPage:=true
        else if UpCase(s[2])='I' then CaseInsensitive:=true
        else if UpCase(s[2])='H' then Usage
        else if s[2]='?' then Usage
        else;
      end
     else SearchStr:=s;
   end;
GetMem(p,ss);
{First pass: gather directory names}
ndir:=1;
if RootDir='' then begin
   ls:=GetCurrentDirectory(ss,p);
   path[1]:=StrPas(p);
   end
  else path[1]:=RootDir;
n1:=1; n2:=1;
repeat
   n3:=0;
   for idir:=n1 to n2 do begin
      StrPCopy(p,path[idir]+'\*.*');
      ffh:=FindFirstFile(p,FR);
      if ffh=INVALID_HANDLE_VALUE then LE:=GetLastError else LE:=0;
      while LE=0 do begin
         fn:=StrPas(FR.cFileName); 
         if (FR.dwFileAttributes and FILE_ATTRIBUTE_DIRECTORY =
          FILE_ATTRIBUTE_DIRECTORY) and (fn<>'.') and (fn<>'..') then begin
            if ndir>maxdir then begin
               Writeln('Too much subdirectories');
               Halt(1);
               end
              else begin
               ndir:=ndir+1; n3:=n3+1;
               path[ndir]:=path[idir]+'\'+fn; 
               end;
            end;
         if FindNextFile(ffh,FR) then LE:=0 else LE:=GetLastError;
         end;
      if not FindClose(ffh) then LE:=GetLastError;
      end;
   if n3>0 then begin
      n1:=n2+1; n2:=ndir;
      end;
   until n3=0;
{order path}
if ndir>2 then for i:=1 to ndir do for j:=i+1 to ndir do
 if path[i]>path[j] then begin
   fn:=path[i];
   path[i]:=path[j];
   path[j]:=fn;
   end;
{Second pass: do the search}
l:=0;
if CaseInsensitive then SearchStr:=UpCase(SearchStr);
for idir:=1 to ndir do begin
   StrPCopy(p,path[idir]+'\'+SearchMask);
   ffh:=FindFirstFile(p,FR);
   if ffh=INVALID_HANDLE_VALUE then LE:=GetLastError else LE:=0;
   while LE=0 do begin
      fn:=StrPas(FR.cFileName);
      found:=false; TextOK:=true;
      Write(Chr(13),Space(79)); Write(Chr(13),path[idir],'\',fn, '  ');
      if (fn='.') or (fn='..') then TextOK:=false;
      if (FR.dwFileAttributes and FILE_ATTRIBUTE_DIRECTORY =
       FILE_ATTRIBUTE_DIRECTORY) then TextOK:=false;
      if TextOK then begin
         {$I-}Assign(f,path[idir]+'\'+fn);
         Reset(f);
         if IOResult<>0 then TextOK:=false;
         while TextOK and not Eof(f) do begin
            Readln(f,s); Rotor;
            if CaseInsensitive then s1:=UpCase(s) else s1:=s;
            if Pos(SearchStr,s1)>0 then begin
               if not found then begin
                  Writeln(Chr(8),'  ');
                  found:=true;
                  end;
               Writeln(Chr(8),'>',s); WaitIfScreenFull;
               end;
            end;
         Close(f);
         i:=IOResult; {$I+}
         end;
      if FindNextFile(ffh,FR) then LE:=0 else LE:=GetLastError;
      end;
   if not FindClose(ffh) then LE:=GetLastError;
   end;
Write(Chr(13),Space(79));
Writeln(Chr(13),'Search ready.'); WaitIfScreenFull;
FreeMem(p,ss);
end.
